# Selected Other MCVaR Core.R
fSIFMCVaRCore = function(FuturesInputData, InitialValuations, Variable){
  Horizon = SimulationInputData$Horizon
  NumberOfSecurities <- 1 # Analysis of only one stock
  NumberOfRandomVariables <- 6.0 # UI1 and 2, LCC1 and 2, SCC1 and 2
  ConfidenceLevel <- SimulationInputData$ConfidenceLevel
  # Extract Name, Units, Price, Mean, Standard Deviation, and Correlation inputs
  Name = SimulationInputData$Name
  Units = FuturesInputData$Units
  Price = FuturesInputData$UI # Just one stock for now
  Mean = as.numeric(c(1:NumberOfRandomVariables))
  Mean[1] <- SimulationInputData$UI1Mean/100.0
  Mean[2] <- SimulationInputData$UI2Mean/100.0
  Mean[3] <- SimulationInputData$LCC1Mean/100.0
  Mean[4] <- SimulationInputData$LCC2Mean/100.0
  Mean[5] <- SimulationInputData$SCC1Mean/100.0
  Mean[6] <- SimulationInputData$SCC2Mean/100.0
  StandardDeviation = as.numeric(c(1:NumberOfRandomVariables))
  StandardDeviation[1] <- SimulationInputData$UI1SD/100.0
  StandardDeviation[2] <- SimulationInputData$UI2SD/100.0
  StandardDeviation[3] <- SimulationInputData$LCC1SD/100.0
  StandardDeviation[4] <- SimulationInputData$LCC2SD/100.0
  StandardDeviation[5] <- SimulationInputData$SCC1SD/100.0
  StandardDeviation[6] <- SimulationInputData$SCC2SD/100.0
  Correlation = matrix(data = 0, nrow = NumberOfRandomVariables, ncol = NumberOfRandomVariables)
  Correlation[1,1] <- Correlation[2,2] <- Correlation[3,3] <- Correlation[4,4] <- Correlation[5,5] <- Correlation[6,6] <- 1.0
  Correlation[1,2] <- Correlation[2,1] <- SimulationInputData$CorUI1UI2
  Correlation[1,3] <- Correlation[3,1] <- SimulationInputData$CorUI1LCC1
  Correlation[1,4] <- Correlation[4,1] <- SimulationInputData$CorUI1LCC2
  Correlation[1,5] <- Correlation[5,1] <- SimulationInputData$CorUI1SCC1
  Correlation[1,6] <- Correlation[6,1] <- SimulationInputData$CorUI1SCC2
  Correlation[2,3] <- Correlation[3,2] <- SimulationInputData$CorUI2LCC1
  Correlation[2,4] <- Correlation[4,2] <- SimulationInputData$CorUI2LCC2
  Correlation[2,5] <- Correlation[5,2] <- SimulationInputData$CorUI2SCC1
  Correlation[2,6] <- Correlation[6,2] <- SimulationInputData$CorUI2SCC2
  Correlation[3,4] <- Correlation[4,3] <- SimulationInputData$CorLCC1LCC2
  Correlation[3,5] <- Correlation[5,3] <- SimulationInputData$CorLCC1SCC1
  Correlation[3,6] <- Correlation[6,3] <- SimulationInputData$CorLCC1SCC2
  Correlation[4,5] <- Correlation[5,4] <- SimulationInputData$CorLCC2SCC1
  Correlation[4,6] <- Correlation[6,4] <- SimulationInputData$CorLCC2SCC2
  Correlation[5,6] <- Correlation[6,5] <- SimulationInputData$CorSCC1SCC2
  Covariance = matrix(nrow = NumberOfRandomVariables, ncol = NumberOfRandomVariables)
  Covariance[1,1] <- StandardDeviation[1]^2
  Covariance[2,2] <- StandardDeviation[2]^2 
  Covariance[3,3] <- StandardDeviation[3]^2 
  Covariance[4,4] <- StandardDeviation[4]^2 
  Covariance[5,5] <- StandardDeviation[5]^2 
  Covariance[6,6] <- StandardDeviation[6]^2 
  Covariance[1,2] <- Covariance[2,1] <- StandardDeviation[1] * StandardDeviation[2] * Correlation[1,2]
  Covariance[1,3] <- Covariance[3,1] <- StandardDeviation[1] * StandardDeviation[3] * Correlation[1,3]
  Covariance[1,4] <- Covariance[4,1] <- StandardDeviation[1] * StandardDeviation[4] * Correlation[1,4]
  Covariance[1,5] <- Covariance[5,1] <- StandardDeviation[1] * StandardDeviation[5] * Correlation[1,5]
  Covariance[1,6] <- Covariance[6,1] <- StandardDeviation[1] * StandardDeviation[6] * Correlation[1,6]
  Covariance[2,3] <- Covariance[3,2] <- StandardDeviation[2] * StandardDeviation[3] * Correlation[2,3]
  Covariance[2,4] <- Covariance[4,2] <- StandardDeviation[2] * StandardDeviation[4] * Correlation[2,4]
  Covariance[2,5] <- Covariance[5,2] <- StandardDeviation[2] * StandardDeviation[5] * Correlation[2,5]
  Covariance[2,6] <- Covariance[6,2] <- StandardDeviation[2] * StandardDeviation[6] * Correlation[2,6]
  Covariance[3,4] <- Covariance[4,3] <- StandardDeviation[3] * StandardDeviation[4] * Correlation[3,4]
  Covariance[3,5] <- Covariance[5,3] <- StandardDeviation[3] * StandardDeviation[5] * Correlation[3,5]
  Covariance[3,6] <- Covariance[6,3] <- StandardDeviation[3] * StandardDeviation[6] * Correlation[3,6]
  Covariance[4,5] <- Covariance[5,4] <- StandardDeviation[4] * StandardDeviation[5] * Correlation[4,5]
  Covariance[4,6] <- Covariance[6,4] <- StandardDeviation[4] * StandardDeviation[6] * Correlation[4,6]
  Covariance[5,6] <- Covariance[6,5] <- StandardDeviation[5] * StandardDeviation[6] * Correlation[5,6]
# Data frame holding outputs
  InitialValuations = data.frame(matrix(NA, nrow = NumberOfStrategies, ncol = 2))
  colnames(InitialValuations)  <- c("InitialValue", "Margin")
  rownames(InitialValuations)  <- c("LUI1", 
    "LUI1SF21", "LUI1SF22", "LUI1SF23", # Long UI1, short futures 2 (nearby 1, 2, and 3)
    "SUI1LF21", "SUI1LF22", "SUI1LF23", # Short UI1, long futures 2 (nearby 1, 2, and 3)
    "LF11SF21", "LF12SF22", "LF13SF23", # Long futures 1, short futures 2 (same maturity)
    "SF11LF21", "SF12LF22", "SF13LF23", # Short futures 1, long futures 2 (same maturity)
    "LF11SF22", "LF11SF23", "LF11SF24", # Long futures 1, short futures 2 (longer maturities)
    "SF11LF22", "SF11LF23", "SF11LF24" # Short futures 1, long futures 2 (longer maturities)
  )         
#
# Source all required functions
#
  source("Selected Other Futures MCVaR Functions.R")
#
# VaR analysis of European-style options
#
  IV <- fInitialValues(FuturesInputData, InitialValuations) # NOTE: This function will change with option models
#
# Set up simulations
#
# Test normal distribution (Normal with mean = Mean and
#   standard deviation = StandardDeviation)
# Sample (s)
  NSim <- SimulationInputData$NumberOfSimulations
# If simulated covariance is not positive definite, then adjust  
  if(!is.positive.definite(Covariance)){ # Is Dmat not positive definite?
    pd_D_mat <- nearPD(Covariance)  # Find nearby positive definite solution
    Covariance = as.matrix(pd_D_mat$mat)
    Errorpd_D_mat <- pd_D_mat
  }
  s = mvrnorm(n = NSim, Mean, Covariance, tol = 1e-6, empirical = FALSE, EISPACK = FALSE)
  sMean = as.numeric(c(1:NumberOfRandomVariables))
  sStandardDeviation = as.numeric(c(1:NumberOfRandomVariables))
  sCorrelation = matrix(nrow = NumberOfRandomVariables, ncol = NumberOfRandomVariables)
  for(i in 1:NumberOfRandomVariables){
    sMean[i] = mean(s[,i])
    sStandardDeviation[i] = sd(s[,i])
    for(j in 1:i){
      sCorrelation[i, j] = cor(s[,i],s[,j])
      sCorrelation[j, i] = sCorrelation[i, j]
    }
  }
  TerminalValuations = data.frame(matrix(NA, nrow = NumberOfStrategies, ncol = NSim))
  colnames(TerminalValuations)  <- seq(1:NSim)
  rownames(TerminalValuations)  <- c("LUI1", 
    "LUI1SF21", "LUI1SF22", "LUI1SF23", # Long UI1, short futures 2 (nearby 1, 2, and 3)
    "SUI1LF21", "SUI1LF22", "SUI1LF23", # Short UI1, long futures 2 (nearby 1, 2, and 3)
    "LF11SF21", "LF12SF22", "LF13SF23", # Long futures 1, short futures 2 (same maturity)
    "SF11LF21", "SF12LF22", "SF13LF23", # Short futures 1, long futures 2 (same maturity)
    "LF11SF22", "LF11SF23", "LF11SF24", # Long futures 1, short futures 2 (longer maturities)
    "SF11LF22", "SF11LF23", "SF11LF24" # Short futures 1, long futures 2 (longer maturities)
  )         
  Horizon <- SimulationInputData$Horizon
  tUI1 <- FuturesInputData$UI1
  tUI2 <- FuturesInputData$UI2
  tLCC1 <- FuturesInputData$LevelCC1
  tLCC2 <- FuturesInputData$LevelCC2
  tSCC1 <- FuturesInputData$SlopeCC1
  tSCC2 <- FuturesInputData$SlopeCC2
  tTimeToMaturity1 <- FuturesInputData$TimeToMaturity1
  tTimeToMaturity2 <- FuturesInputData$TimeToMaturity2
  FuturesInputData$TimeToMaturity1 <- tTimeToMaturity1 - Horizon 
  FuturesInputData$TimeToMaturity2 <- tTimeToMaturity2 - Horizon 
  for(i in 1:NSim){
    FuturesInputData$UI1 <- tUI1*exp(s[i,1]*Horizon)  
    FuturesInputData$UI2 <- tUI2*exp(s[i,2]*Horizon)  
    FuturesInputData$LevelCC1 <- tLCC1 + s[i,3]*Horizon
    FuturesInputData$LevelCC2 <- tLCC2 + s[i,4]*Horizon
    FuturesInputData$SlopeCC1 <- tSCC1 + s[i,5]*Horizon
    FuturesInputData$SlopeCC2 <- tSCC2 + s[i,6]*Horizon
    tempTV <- fInitialValues(FuturesInputData, InitialValuations)
    TerminalValuations[,i] <- tempTV["InitialValue"]
  }
# Replace original values  
  FuturesInputData$UI1 <- tUI1
  FuturesInputData$UI2 <- tUI2
  FuturesInputData$LevelCC1 <- tLCC1
  FuturesInputData$LevelCC2 <- tLCC2
  FuturesInputData$SlopeCC1 <- tSCC1
  FuturesInputData$SlopeCC2 <- tSCC2
  FuturesInputData$TimeToMaturity1 <- tTimeToMaturity1
  FuturesInputData$TimeToMaturity2 <- tTimeToMaturity2
#
# Compute VaR for each strategy
# 
  TerminalValue <- rep(-99, 19)
  Valuations <- cbind(IV, TerminalValue)
  VaR <- rep(-99, 19)
  Valuations <- cbind(Valuations, VaR)
  RVaR <- rep(-99, 19)
  Valuations <- cbind(Valuations, RVaR)
  for(i in 1:NumberOfStrategies){
    tVector <- as.matrix(TerminalValuations[i,])
    VaRTV <- as.numeric(quantile(tVector, 1-ConfidenceLevel/100))
    Valuations[i,3] <- as.numeric(VaRTV)
    Valuations[i,4] <- -(as.numeric(Valuations[i,3]) - as.numeric(Valuations[i,1])) 
    Valuations[i,5] <- (Valuations[i,4]/Valuations[i,2])*100.0
  }
  Valuations <- round(Valuations,2)  
  
  
  
# Record base case information  
  if(BASECASE){
    Valuations <- cbind(Strategy = rownames(Valuations), Valuations)
    rownames(Valuations) <- 1:nrow(Valuations)
    Tab <- "VaR Output"
    wb <- buildWorkbook(Valuations, sheetName = Tab, gridLines = TRUE)
# Input option data
    Tab <- "Futures Parameters"
    addWorksheet(wb, sheetName = Tab, gridLines = TRUE)
    FuturesInputData <- t(FuturesInputData)
    FuturesInputData <- cbind(Strategy = rownames(FuturesInputData), FuturesInputData)
    rownames(FuturesInputData) <- 1:nrow(FuturesInputData)
    writeData(wb, Tab, FuturesInputData)
# Input simulation data
    Tab <- "Simulation Parameters"
    addWorksheet(wb, sheetName = Tab, gridLines = TRUE)
    SimulationInputData <- as.data.frame(SimulationInputData)
    SimulationInputData <- t(SimulationInputData)
    SimulationInputData <- cbind(Parameters = rownames(SimulationInputData), SimulationInputData)
    rownames(SimulationInputData) <- 1:nrow(SimulationInputData)
    writeData(wb, Tab, SimulationInputData)
#
# Build data frame to contain both input simulation parameters as well as output
#
    dfMean <- as.data.frame(Mean)
    colnames(dfMean)  <- c("PopMean")
    dfSMean <- as.data.frame(sMean)
    colnames(dfSMean)  <- c("SamMean")
    dfStandardDeviation <- as.data.frame(StandardDeviation)
    colnames(dfStandardDeviation)  <- c("PopSD")
    dfSStandardDeviation <- as.data.frame(sStandardDeviation)
    colnames(dfSStandardDeviation)  <- c("SamSD")
    dfCorrelation <- as.data.frame(Correlation)
    colnames(dfCorrelation)  <- c("PopUI1", "PopUI2", "PopLCC1", "PopLCC2", "PopSCC1",  "PopSCC2")
    dfSCorrelation <- as.data.frame(sCorrelation)
    colnames(dfSCorrelation)  <- c("SamUI1", "SamUI2", "SamLCC1", "SamLCC2", "SamSCC1",  "SamSCC2")
    dfMean <- dfMean*100
    dfSMean <- dfSMean*100
    dfStandardDeviation <- dfStandardDeviation*100
    dfSStandardDeviation <- dfSStandardDeviation*100
    SimParameters <- cbind(dfMean, dfSMean, dfStandardDeviation, dfSStandardDeviation,
      dfCorrelation, dfSCorrelation)
    SimParameters <- round(SimParameters, 2)
    rownames(SimParameters)  <- c("IU1", "IU2", "LevelCC1", "LevelCC2", "SlopeCC1", "SlopeCC2")
    SimParameters <- cbind(Parameters = rownames(SimParameters), SimParameters)
    Tab <- "Simulation Statistics"
    addWorksheet(wb, sheetName = Tab, gridLines = TRUE)
    writeData(wb, Tab, SimParameters)
    FilePath <- "Selected Output/"
    WorkBookName <- paste0(FilePath, 'SIF VaR and Valuations ', Variable, ' 1', '.xlsx')
    saveWorkbook(wb, WorkBookName, overwrite = TRUE)
  }
  return(Valuations)
}
