# SWAP MCVaR Core.R
fSWAPMCVaRCore = function(SimSWAP, MVNSimulationParameters, InitialValuations, Variable){
  NumberOfSecurities <- 1 # Analysis of only one swap
  NumberOfRandomVariables <- 6.0 # FC and BC, 3 LSC parameters
  ConfidenceLevel <- SimSWAP$ConfidenceLevel
# Extract values
  Name = SimSWAP$TradeName
  # Units = FuturesInputData$Units
  # Price = FuturesInputData$UI # Just one stock for now
  Mean = as.numeric(c(1:NumberOfRandomVariables))
  Mean[1] <- MVNSimulationParameters$FDMean[1]*SimSWAP$HorizonInYears
  Mean[2] <- MVNSimulationParameters$FDMean[2]*SimSWAP$HorizonInYears
  Mean[3] <- MVNSimulationParameters$FDMean[3]*SimSWAP$HorizonInYears
  Mean[4] <- MVNSimulationParameters$FDMean[4]*SimSWAP$HorizonInYears
  Mean[5] <- MVNSimulationParameters$FDMean[5]*SimSWAP$HorizonInYears
  Mean[6] <- MVNSimulationParameters$FDMean[6]*SimSWAP$HorizonInYears
  StandardDeviation = as.numeric(c(1:NumberOfRandomVariables))
  StandardDeviation[1] <- MVNSimulationParameters$FDSD[1]*sqrt(SimSWAP$HorizonInYears)
  StandardDeviation[2] <- MVNSimulationParameters$FDSD[2]*sqrt(SimSWAP$HorizonInYears)
  StandardDeviation[3] <- MVNSimulationParameters$FDSD[3]*sqrt(SimSWAP$HorizonInYears)
  StandardDeviation[4] <- MVNSimulationParameters$FDSD[4]*sqrt(SimSWAP$HorizonInYears)
  StandardDeviation[5] <- MVNSimulationParameters$FDSD[5]*sqrt(SimSWAP$HorizonInYears)
  StandardDeviation[6] <- MVNSimulationParameters$FDSD[6]*sqrt(SimSWAP$HorizonInYears)
  Correlation = matrix(data = 0, nrow = NumberOfRandomVariables, ncol = NumberOfRandomVariables)
  Correlation[1,1] <- Correlation[2,2] <- Correlation[3,3] <- Correlation[4,4] <- Correlation[5,5] <- Correlation[6,6] <- 1.0
  Correlation[1,2] <- Correlation[2,1] <- MVNSimulationParameters$FDFCLevel[2]
  Correlation[1,3] <- Correlation[3,1] <- MVNSimulationParameters$FDFCLevel[3]
  Correlation[1,4] <- Correlation[4,1] <- MVNSimulationParameters$FDFCLevel[4]
  Correlation[1,5] <- Correlation[5,1] <- MVNSimulationParameters$FDFCLevel[5]
  Correlation[1,6] <- Correlation[6,1] <- MVNSimulationParameters$FDFCLevel[6]
  Correlation[2,3] <- Correlation[3,2] <- MVNSimulationParameters$FDFCSlope[3]
  Correlation[2,4] <- Correlation[4,2] <- MVNSimulationParameters$FDFCSlope[4]
  Correlation[2,5] <- Correlation[5,2] <- MVNSimulationParameters$FDFCSlope[5]
  Correlation[2,6] <- Correlation[6,2] <- MVNSimulationParameters$FDFCSlope[6]
  Correlation[3,4] <- Correlation[4,3] <- MVNSimulationParameters$FDFCCurvature1[4]
  Correlation[3,5] <- Correlation[5,3] <- MVNSimulationParameters$FDFCCurvature1[5]
  Correlation[3,6] <- Correlation[6,3] <- MVNSimulationParameters$FDFCCurvature1[6]
  Correlation[4,5] <- Correlation[5,4] <- MVNSimulationParameters$FDBCLevel[5]
  Correlation[4,6] <- Correlation[6,4] <- MVNSimulationParameters$FDBCLevel[6]
  Correlation[5,6] <- Correlation[6,5] <- MVNSimulationParameters$FDBCSlope[6]
  Covariance = matrix(nrow = NumberOfRandomVariables, ncol = NumberOfRandomVariables)
  Covariance[1,1] <- StandardDeviation[1]^2
  Covariance[2,2] <- StandardDeviation[2]^2 
  Covariance[3,3] <- StandardDeviation[3]^2 
  Covariance[4,4] <- StandardDeviation[4]^2 
  Covariance[5,5] <- StandardDeviation[5]^2 
  Covariance[6,6] <- StandardDeviation[6]^2 
  Covariance[1,2] <- Covariance[2,1] <- StandardDeviation[1] * StandardDeviation[2] * Correlation[1,2]
  Covariance[1,3] <- Covariance[3,1] <- StandardDeviation[1] * StandardDeviation[3] * Correlation[1,3]
  Covariance[1,4] <- Covariance[4,1] <- StandardDeviation[1] * StandardDeviation[4] * Correlation[1,4]
  Covariance[1,5] <- Covariance[5,1] <- StandardDeviation[1] * StandardDeviation[5] * Correlation[1,5]
  Covariance[1,6] <- Covariance[6,1] <- StandardDeviation[1] * StandardDeviation[6] * Correlation[1,6]
  Covariance[2,3] <- Covariance[3,2] <- StandardDeviation[2] * StandardDeviation[3] * Correlation[2,3]
  Covariance[2,4] <- Covariance[4,2] <- StandardDeviation[2] * StandardDeviation[4] * Correlation[2,4]
  Covariance[2,5] <- Covariance[5,2] <- StandardDeviation[2] * StandardDeviation[5] * Correlation[2,5]
  Covariance[2,6] <- Covariance[6,2] <- StandardDeviation[2] * StandardDeviation[6] * Correlation[2,6]
  Covariance[3,4] <- Covariance[4,3] <- StandardDeviation[3] * StandardDeviation[4] * Correlation[3,4]
  Covariance[3,5] <- Covariance[5,3] <- StandardDeviation[3] * StandardDeviation[5] * Correlation[3,5]
  Covariance[3,6] <- Covariance[6,3] <- StandardDeviation[3] * StandardDeviation[6] * Correlation[3,6]
  Covariance[4,5] <- Covariance[5,4] <- StandardDeviation[4] * StandardDeviation[5] * Correlation[4,5]
  Covariance[4,6] <- Covariance[6,4] <- StandardDeviation[4] * StandardDeviation[6] * Correlation[4,6]
  Covariance[5,6] <- Covariance[6,5] <- StandardDeviation[5] * StandardDeviation[6] * Correlation[5,6]
# Data frame holding outputs
  InitialValuations = data.frame(matrix(NA, nrow = NumberOfStrategies, ncol = 2))
  colnames(InitialValuations)  <- c("InitialValue", "Collateral")
  rownames(InitialValuations)  <- c("SIC", 
    "SMD1Y", "SMD2Y", "SMD3Y", "SMD4Y", "SMD5Y", "SMD10Y", "SMD20Y", "SMD30Y", 
    "SDCPV", "SDC30S", "SDC30Q", "SDCACTQ",
    "SFRM2", "SFRM1", "SFRP1", "SFRP2", 
    "SCC10", "SCC20"
  )   
#
# Source all required functions
#
  source("Swap MCVaR Functions.R")
#
# VaR analysis of European-style options
#
  INITIAL <- TRUE
  IV <- fInitialValues(SimSWAP, InitialValuations, INITIAL) # NOTE: This function will change with option models
#
# Set up simulations
#
# Test normal distribution (Normal with mean = Mean and
#   standard deviation = StandardDeviation)
# Sample (s)
  NSim <- SimSWAP$NumberOfSimulations
# If simulated covariance is not positive definite, then adjust
  if(!is.positive.definite(Covariance)){ # Is Dmat not positive definite?
    pd_D_mat <- nearPD(Covariance)  # Find nearby positive definite solution
    Covariance = as.matrix(pd_D_mat$mat)
    Errorpd_D_mat <- pd_D_mat
  }
  s = mvrnorm(n = NSim, Mean, Covariance, tol = 1e-6, empirical = FALSE, EISPACK = FALSE)
  sMean = as.numeric(c(1:NumberOfRandomVariables))
  sStandardDeviation = as.numeric(c(1:NumberOfRandomVariables))
  sCorrelation = matrix(nrow = NumberOfRandomVariables, ncol = NumberOfRandomVariables)
  for(i in 1:NumberOfRandomVariables){
    sMean[i] = mean(s[,i])/SimSWAP$HorizonInYears
    sStandardDeviation[i] = sd(s[,i])/sqrt(SimSWAP$HorizonInYears)
    for(j in 1:i){
      sCorrelation[i, j] = cor(s[,i],s[,j])
      sCorrelation[j, i] = sCorrelation[i, j]
    }
  }
  TerminalValuations = data.frame(matrix(NA, nrow = NumberOfStrategies, ncol = NSim))
  colnames(TerminalValuations)  <- seq(1:NSim)
  rownames(TerminalValuations)  <- c("SIC",
  "SMD1Y", "SMD2Y", "SMD3Y", "SMD4Y", "SMD5Y", "SMD10Y", "SMD20Y", "SMD30Y", 
  "SDCPV", "SDC30S", "SDC30Q", "SDCACTQ",
  "SFRM2", "SFRM1", "SFRP1", "SFRP2", 
  "SCC10", "SCC20"
  )
# Adjust horizon via switch (INITIAL: True use settle date, False use horizon date)
  INITIAL <- FALSE
# Compute Horizon in fraction of year
  JEvaluationDate <- AdjustDate(SimSWAP$EM, SimSWAP$ED, SimSWAP$EY, FixConv)
  JHorizonDate <- AdjustDate(SimSWAP$HM, SimSWAP$HD, SimSWAP$HY, FixConv)
  Horizon <- (as.numeric(JHorizonDate) - as.numeric(JEvaluationDate))/365.0
# Save initial values
  tFRParm1 <- SimSWAP$FRParm1 
  tFRParm2 <- SimSWAP$FRParm2
  tFRParm3 <- SimSWAP$FRParm3
  tGRParm1 <- SimSWAP$GRParm1
  tGRParm1 <- SimSWAP$GRParm2
  tGRParm1 <- SimSWAP$GRParm3
# Run through each simulation and compute terminal values
  for(ik in 1:NSim){ # Eventually generalize to n factors
    SimSWAP$FRParm1 <- tFRParm1 + s[ik,1]
    SimSWAP$FRParm2 <- tFRParm2 + s[ik,2]
    SimSWAP$FRParm3 <- tFRParm3 + s[ik,3]
    SimSWAP$GRParm1 <- tGRParm1 + s[ik,4]
    SimSWAP$GRParm2 <- tGRParm2 + s[ik,5]
    SimSWAP$GRParm3 <- tGRParm3 + s[ik,6]
    tempTV <- fInitialValues(SimSWAP, InitialValuations, INITIAL)
    TerminalValuations[,ik] <- tempTV["InitialValue"]
  }
# Restore initial values
  SimSWAP$FRParm1 <- tFRParm1
  SimSWAP$FRParm2 <- tFRParm2
  SimSWAP$FRParm3 <- tFRParm3
  SimSWAP$GRParm1 <- tGRParm1
  SimSWAP$GRParm2 <- tGRParm2
  SimSWAP$GRParm3 <- tGRParm3
#
# Compute VaR for each strategy
#
  TerminalValue <- rep(-99, 19)
  Valuations <- cbind(IV, TerminalValue)
  VaR <- rep(-99, 19)
  Valuations <- cbind(Valuations, VaR)
  RVaR <- rep(-99, 19)
  Valuations <- cbind(Valuations, RVaR)
  for(i in 1:NumberOfStrategies){
    tVector <- as.matrix(TerminalValuations[i,])
    VaRTV <- as.numeric(quantile(tVector, 1-ConfidenceLevel/100))
    Valuations[i,3] <- as.numeric(VaRTV)
    Valuations[i,4] <- -(as.numeric(Valuations[i,3]) - as.numeric(Valuations[i,1]))
    Valuations[i,5] <- (Valuations[i,4]/Valuations[i,2])*100.0
  }
  Valuations <- round(Valuations,2)
# Record base case information
  if(BASECASE){
    Valuations <- cbind(Strategy = rownames(Valuations), Valuations)
    rownames(Valuations) <- 1:nrow(Valuations)
    Tab <- "VaR Output"
    wb1 <- buildWorkbook(Valuations, sheetName = Tab, gridLines = TRUE)
# Input option data
    Tab <- "Swap Parameters"
    addWorksheet(wb1, sheetName = Tab, gridLines = TRUE)
    SwapInputData <- t(SimSWAP)
    SwapInputData <- cbind(Strategy = rownames(SwapInputData), SwapInputData)
    rownames(SwapInputData) <- 1:nrow(SwapInputData)
    writeData(wb1, Tab, SwapInputData)
# Input simulation data
    Tab <- "Simulation Parameters"
    addWorksheet(wb1, sheetName = Tab, gridLines = TRUE)
    MVNSimulationParameters <- as.data.frame(MVNSimulationParameters)
    MVNSimulationParameters <- t(MVNSimulationParameters)
    MVNSimulationParameters <- cbind(Parameters = rownames(MVNSimulationParameters), MVNSimulationParameters)
    rownames(MVNSimulationParameters) <- 1:nrow(MVNSimulationParameters)
    writeData(wb1, Tab, MVNSimulationParameters)
#
# Build data frame to contain both input simulation parameters as well as output
#
    dfMean <- as.data.frame(Mean)
    colnames(dfMean)  <- c("PopMean")
    dfSMean <- as.data.frame(sMean)
    colnames(dfSMean)  <- c("SamMean")
    dfStandardDeviation <- as.data.frame(StandardDeviation)
    colnames(dfStandardDeviation)  <- c("PopSD")
    dfSStandardDeviation <- as.data.frame(sStandardDeviation)
    colnames(dfSStandardDeviation)  <- c("SamSD")
    dfCorrelation <- as.data.frame(Correlation)
    colnames(dfCorrelation)  <- c("PopFDFRLevel", "PopFDFRSlope", "PopFDFRCurve1", 
      "PopFDBCLevel", "PopFDBCSlope", "PopFDBCCurve1")
    dfSCorrelation <- as.data.frame(sCorrelation)
    colnames(dfSCorrelation)  <- c("SamFDFRLevel", "SamFDFRSlope", "SamFDFRCurve1", 
      "SamFDBCLevel", "SamFDBCSlope", "SamFDBCCurve1")
    dfMean <- dfMean*100
    dfSMean <- dfSMean*100
    dfStandardDeviation <- dfStandardDeviation
    dfSStandardDeviation <- dfSStandardDeviation
    SimParameters <- cbind(dfMean, dfSMean, dfStandardDeviation, dfSStandardDeviation,
      dfCorrelation, dfSCorrelation)
    SimParameters <- round(SimParameters, 2)
    rownames(SimParameters)  <- c("FDFRLevel", "FDFRSlope", "FDFRCurve1", 
      "FDBCLevel", "FDBCSlope", "FDBCCurve1")
    SimParameters <- cbind(Parameters = rownames(SimParameters), SimParameters)
    Tab <- "Simulation Statistics"
    addWorksheet(wb1, sheetName = Tab, gridLines = TRUE)
    writeData(wb1, Tab, SimParameters)
    FilePath <- "Selected Output/"
    WorkBookName <- paste0(FilePath, 'Swap VaR and Valuations ', Variable, ' 1', '.xlsx')
    saveWorkbook(wb1, WorkBookName, overwrite = TRUE)
    rm(wb1)
  }
  return(Valuations)
}
