# Swap MCVaR Functions.R
#
# source("FCAVM With SRM Functions.R")
#
# Portfolio risk management functions
#
# Set initial values for 19 positions

fInitialValues = function(SimSWAP, InitialValuations, INITIAL){
  tIV <- InitialValuations
  # tSimSWAP <- SimSWAP # Temporary swap parameters evaluated by simulation
  # tSwapValue <- SwapRateGC(tSimSWAP)
# 1) (SIC) Long underlying instrument 1
  tSimSWAP <- SimSWAP # Temporary swap parameters evaluated by simulation
  if(!INITIAL){
    tSimSWAP$EM <- tSimSWAP$HM
    tSimSWAP$ED <- tSimSWAP$HD
    tSimSWAP$EY <- tSimSWAP$HY
  }
  
  tSimSWAP
  
  tSwapValue <- SwapRateGC(tSimSWAP)
  tIV["SIC", "InitialValue"] <- tSwapValue
  tIV["SIC", "Collateral"] <- (tSimSWAP$CashCollateral/100)*tSimSWAP$NAmt
# 2) (SMD1Y) Underlying swap with maturity date = 1 year
  tSimSWAP <- SimSWAP # Reset to initial swap parameters
  tSimSWAP$MM <- tSimSWAP$EM
  tSimSWAP$MD <- tSimSWAP$ED
  tSimSWAP$MY <- tSimSWAP$EY + 1
  if(!INITIAL){
    tSimSWAP$EM <- tSimSWAP$HM
    tSimSWAP$ED <- tSimSWAP$HD
    tSimSWAP$EY <- tSimSWAP$HY
  }
  tSwapValue <- SwapRateGC(tSimSWAP)
  tIV["SMD1Y", "InitialValue"] <- tSwapValue
  tIV["SMD1Y", "Collateral"] <- (tSimSWAP$CashCollateral/100)*tSimSWAP$NAmt
# 3) (SMD2Y) Underlying swap with maturity date = 2 years
  tSimSWAP <- SimSWAP # Reset to initial swap parameters
  tSimSWAP$MM <- tSimSWAP$EM
  tSimSWAP$MD <- tSimSWAP$ED
  tSimSWAP$MY <- tSimSWAP$EY + 2
  if(!INITIAL){
    tSimSWAP$EM <- tSimSWAP$HM
    tSimSWAP$ED <- tSimSWAP$HD
    tSimSWAP$EY <- tSimSWAP$HY
  }
  tSwapValue <- SwapRateGC(tSimSWAP)
  tIV["SMD2Y", "InitialValue"] <- tSwapValue
  tIV["SMD2Y", "Collateral"] <- (tSimSWAP$CashCollateral/100)*tSimSWAP$NAmt
# 4) (SMD3Y) Underlying swap with maturity date = 3 years
  tSimSWAP <- SimSWAP # Reset to initial swap parameters
  tSimSWAP$MM <- tSimSWAP$EM
  tSimSWAP$MD <- tSimSWAP$ED
  tSimSWAP$MY <- tSimSWAP$EY + 3
  if(!INITIAL){
    tSimSWAP$EM <- tSimSWAP$HM
    tSimSWAP$ED <- tSimSWAP$HD
    tSimSWAP$EY <- tSimSWAP$HY
  }
  tSwapValue <- SwapRateGC(tSimSWAP)
  tIV["SMD3Y", "InitialValue"] <- tSwapValue
  tIV["SMD3Y", "Collateral"] <- (tSimSWAP$CashCollateral/100)*tSimSWAP$NAmt
# 5) (SMD4Y) Underlying swap with maturity date = 4 years
  tSimSWAP <- SimSWAP # Reset to initial swap parameters
  tSimSWAP$MM <- tSimSWAP$EM
  tSimSWAP$MD <- tSimSWAP$ED
  tSimSWAP$MY <- tSimSWAP$EY + 4
  if(!INITIAL){
    tSimSWAP$EM <- tSimSWAP$HM
    tSimSWAP$ED <- tSimSWAP$HD
    tSimSWAP$EY <- tSimSWAP$HY
  }
  tSwapValue <- SwapRateGC(tSimSWAP)
  tIV["SMD4Y", "InitialValue"] <- tSwapValue
  tIV["SMD4Y", "Collateral"] <- (tSimSWAP$CashCollateral/100)*tSimSWAP$NAmt
# 6) (SMD5Y) Underlying swap with maturity date = 5 years
  tSimSWAP <- SimSWAP # Reset to initial swap parameters
  tSimSWAP$MM <- tSimSWAP$EM
  tSimSWAP$MD <- tSimSWAP$ED
  tSimSWAP$MY <- tSimSWAP$EY + 5
  if(!INITIAL){
    tSimSWAP$EM <- tSimSWAP$HM
    tSimSWAP$ED <- tSimSWAP$HD
    tSimSWAP$EY <- tSimSWAP$HY
  }
  tSwapValue <- SwapRateGC(tSimSWAP)
  tIV["SMD5Y", "InitialValue"] <- tSwapValue
  tIV["SMD5Y", "Collateral"] <- (tSimSWAP$CashCollateral/100)*tSimSWAP$NAmt
# 7) (SMD10Y) Underlying swap with maturity date = 10 years
  tSimSWAP <- SimSWAP # Reset to initial swap parameters
  tSimSWAP$MM <- tSimSWAP$EM
  tSimSWAP$MD <- tSimSWAP$ED
  tSimSWAP$MY <- tSimSWAP$EY + 10
  if(!INITIAL){
    tSimSWAP$EM <- tSimSWAP$HM
    tSimSWAP$ED <- tSimSWAP$HD
    tSimSWAP$EY <- tSimSWAP$HY
  }
  tSwapValue <- SwapRateGC(tSimSWAP)
  tIV["SMD10Y", "InitialValue"] <- tSwapValue
  tIV["SMD10Y", "Collateral"] <- (tSimSWAP$CashCollateral/100)*tSimSWAP$NAmt
# 8) (SMD20Y) Underlying swap with maturity date = 20 years
  tSimSWAP <- SimSWAP # Reset to initial swap parameters
  tSimSWAP$MM <- tSimSWAP$EM
  tSimSWAP$MD <- tSimSWAP$ED
  tSimSWAP$MY <- tSimSWAP$EY + 20
  if(!INITIAL){
    tSimSWAP$EM <- tSimSWAP$HM
    tSimSWAP$ED <- tSimSWAP$HD
    tSimSWAP$EY <- tSimSWAP$HY
  }
  tSwapValue <- SwapRateGC(tSimSWAP)
  tIV["SMD20Y", "InitialValue"] <- tSwapValue
  tIV["SMD20Y", "Collateral"] <- (tSimSWAP$CashCollateral/100)*tSimSWAP$NAmt
# 9) (SMD30Y) Underlying swap with maturity date = 30 years
  tSimSWAP <- SimSWAP # Reset to initial swap parameters
  tSimSWAP$MM <- tSimSWAP$EM
  tSimSWAP$MD <- tSimSWAP$ED
  tSimSWAP$MY <- tSimSWAP$EY + 30
  if(!INITIAL){
    tSimSWAP$EM <- tSimSWAP$HM
    tSimSWAP$ED <- tSimSWAP$HD
    tSimSWAP$EY <- tSimSWAP$HY
  }
  tSwapValue <- SwapRateGC(tSimSWAP)
  tIV["SMD30Y", "InitialValue"] <- tSwapValue
  tIV["SMD30Y", "Collateral"] <- (tSimSWAP$CashCollateral/100)*tSimSWAP$NAmt
# 10)	Underlying swap with fixed 30/360, Semi and floating ACT/360, Quart: (SDCPV)
  tSimSWAP <- SimSWAP # Reset to initial swap parameters
  tSimSWAP$FixPF <- 2
  tSimSWAP$FltPF <- 4
  tSimSWAP$FixNTD <- 360
  tSimSWAP$FltNTD <- 360
  tSimSWAP$FixNAD <- 1
  tSimSWAP$FltNAD <- 0
  if(!INITIAL){
    tSimSWAP$EM <- tSimSWAP$HM
    tSimSWAP$ED <- tSimSWAP$HD
    tSimSWAP$EY <- tSimSWAP$HY
  }
  tSwapValue <- SwapRateGC(tSimSWAP)
  tIV["SDCPV", "InitialValue"] <- tSwapValue
  tIV["SDCPV", "Collateral"] <- (tSimSWAP$CashCollateral/100)*tSimSWAP$NAmt
# 11)	Underlying swap with both legs 30/360 Semi: (SDC30S)
  tSimSWAP <- SimSWAP # Reset to initial swap parameters
  tSimSWAP$FixPF <- 2
  tSimSWAP$FltPF <- 2
  tSimSWAP$FixNTD <- 360
  tSimSWAP$FltNTD <- 360
  tSimSWAP$FixNAD <- 1
  tSimSWAP$FltNAD <- 1
  if(!INITIAL){
    tSimSWAP$EM <- tSimSWAP$HM
    tSimSWAP$ED <- tSimSWAP$HD
    tSimSWAP$EY <- tSimSWAP$HY
  }
  tSwapValue <- SwapRateGC(tSimSWAP)
  tIV["SDC30S", "InitialValue"] <- tSwapValue
  tIV["SDC30S", "Collateral"] <- (tSimSWAP$CashCollateral/100)*tSimSWAP$NAmt
# 12)	Underlying swap with both legs 30/360 Quart: (SDC30Q)
  tSimSWAP <- SimSWAP # Reset to initial swap parameters
  tSimSWAP$FixPF <- 4
  tSimSWAP$FltPF <- 4
  tSimSWAP$FixNTD <- 360
  tSimSWAP$FltNTD <- 360
  tSimSWAP$FixNAD <- 1
  tSimSWAP$FltNAD <- 1
  if(!INITIAL){
    tSimSWAP$EM <- tSimSWAP$HM
    tSimSWAP$ED <- tSimSWAP$HD
    tSimSWAP$EY <- tSimSWAP$HY
  }
  tSwapValue <- SwapRateGC(tSimSWAP)
  tIV["SDC30Q", "InitialValue"] <- tSwapValue
  tIV["SDC30Q", "Collateral"] <- (tSimSWAP$CashCollateral/100)*tSimSWAP$NAmt
# 13)	Underlying swap with both legs ACT/360 Quart: (SDCACTQ)
  tSimSWAP <- SimSWAP # Reset to initial swap parameters
  tSimSWAP$FixPF <- 4
  tSimSWAP$FltPF <- 4
  tSimSWAP$FixNTD <- 360
  tSimSWAP$FltNTD <- 360
  tSimSWAP$FixNAD <- 0
  tSimSWAP$FltNAD <- 0
  if(!INITIAL){
    tSimSWAP$EM <- tSimSWAP$HM
    tSimSWAP$ED <- tSimSWAP$HD
    tSimSWAP$EY <- tSimSWAP$HY
  }
  tSwapValue <- SwapRateGC(tSimSWAP)
  tIV["SDCACTQ", "InitialValue"] <- tSwapValue
  tIV["SDCACTQ", "Collateral"] <- (tSimSWAP$CashCollateral/100)*tSimSWAP$NAmt
# 14)	(SFRM2) Underlying swap with 2 percent decrease in fixed rate
  tSimSWAP <- SimSWAP # Reset to initial swap parameters
  tSimSWAP$FixedRate <- tSimSWAP$FixedRate - 2.0
  if(!INITIAL){
    tSimSWAP$EM <- tSimSWAP$HM
    tSimSWAP$ED <- tSimSWAP$HD
    tSimSWAP$EY <- tSimSWAP$HY
  }
  tSwapValue <- SwapRateGC(tSimSWAP)
  tIV["SFRM2", "InitialValue"] <- tSwapValue
  tIV["SFRM2", "Collateral"] <- (tSimSWAP$CashCollateral/100)*tSimSWAP$NAmt
# 15)	(SFRM1) Underlying swap with 1 percent decrease in fixed rate
  tSimSWAP <- SimSWAP # Reset to initial swap parameters
  tSimSWAP$FixedRate <- tSimSWAP$FixedRate - 1.0
  if(!INITIAL){
    tSimSWAP$EM <- tSimSWAP$HM
    tSimSWAP$ED <- tSimSWAP$HD
    tSimSWAP$EY <- tSimSWAP$HY
  }
  tSwapValue <- SwapRateGC(tSimSWAP)
  tIV["SFRM1", "InitialValue"] <- tSwapValue
  tIV["SFRM1", "Collateral"] <- (tSimSWAP$CashCollateral/100)*tSimSWAP$NAmt
# 16)	(SFRP1) Underlying swap with 1 percent increase in fixed rate
  tSimSWAP <- SimSWAP # Reset to initial swap parameters
  tSimSWAP$FixedRate <- tSimSWAP$FixedRate + 1.0
  if(!INITIAL){
    tSimSWAP$EM <- tSimSWAP$HM
    tSimSWAP$ED <- tSimSWAP$HD
    tSimSWAP$EY <- tSimSWAP$HY
  }
  tSwapValue <- SwapRateGC(tSimSWAP)
  tIV["SFRP1", "InitialValue"] <- tSwapValue
  tIV["SFRP1", "Collateral"] <- (tSimSWAP$CashCollateral/100)*tSimSWAP$NAmt
# 17)	(SFRP2) Underlying swap with 2 percent increase in fixed rate
  tSimSWAP <- SimSWAP # Reset to initial swap parameters
  tSimSWAP$FixedRate <- tSimSWAP$FixedRate + 2.0
  if(!INITIAL){
    tSimSWAP$EM <- tSimSWAP$HM
    tSimSWAP$ED <- tSimSWAP$HD
    tSimSWAP$EY <- tSimSWAP$HY
  }
  tSwapValue <- SwapRateGC(tSimSWAP)
  tIV["SFRP2", "InitialValue"] <- tSwapValue
  tIV["SFRP2", "Collateral"] <- (tSimSWAP$CashCollateral/100)*tSimSWAP$NAmt
# 18)	(SCC10) Underlying swap with +10 percent point increase in cash collateral
  tSimSWAP <- SimSWAP # Reset to initial swap parameters
  tSimSWAP$CashCollateral <- 10
  if(!INITIAL){
    tSimSWAP$EM <- tSimSWAP$HM
    tSimSWAP$ED <- tSimSWAP$HD
    tSimSWAP$EY <- tSimSWAP$HY
  }
  tSwapValue <- SwapRateGC(tSimSWAP)
  tIV["SCC10", "InitialValue"] <- tSwapValue
  tIV["SCC10", "Collateral"] <- (tSimSWAP$CashCollateral/100)*tSimSWAP$NAmt
# 19)	(SCC20) Underlying swap with +10 percent point increase in cash collateral
  tSimSWAP <- SimSWAP # Reset to initial swap parameters
  tSimSWAP$CashCollateral <- 20
  if(!INITIAL){
    tSimSWAP$EM <- tSimSWAP$HM
    tSimSWAP$ED <- tSimSWAP$HD
    tSimSWAP$EY <- tSimSWAP$HY
  }
  tSwapValue <- SwapRateGC(tSimSWAP)
  tIV["SCC20", "InitialValue"] <- tSwapValue
  tIV["SCC20", "Collateral"] <- (tSimSWAP$CashCollateral/100)*tSimSWAP$NAmt
  return(tIV)
}


